"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _reduxQuery = require("redux-query");

var _context = _interopRequireDefault(require("../context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const useQueryState = queryConfig => {
  const contextValue = React.useContext(_context.default);

  if (!contextValue) {
    throw new Error(`Could not find redux-query-react's context. Be sure to render a redux-query <Provider> near the root of your React tree.`);
  }

  const {
    queriesSelector
  } = contextValue;
  const isPending = (0, _reactRedux.useSelector)(state => _reduxQuery.querySelectors.isPending(queriesSelector(state), queryConfig));
  const isFinished = (0, _reactRedux.useSelector)(state => _reduxQuery.querySelectors.isFinished(queriesSelector(state), queryConfig));
  const status = (0, _reactRedux.useSelector)(state => _reduxQuery.querySelectors.status(queriesSelector(state), queryConfig));
  const headers = (0, _reactRedux.useSelector)(state => _reduxQuery.querySelectors.headers(queriesSelector(state), queryConfig));
  const lastUpdated = (0, _reactRedux.useSelector)(state => _reduxQuery.querySelectors.lastUpdated(queriesSelector(state), queryConfig));
  const queryCount = (0, _reactRedux.useSelector)(state => _reduxQuery.querySelectors.queryCount(queriesSelector(state), queryConfig));
  const queryState = React.useMemo(() => ({
    isPending,
    isFinished,
    status,
    headers,
    lastUpdated,
    queryCount
  }), [headers, isFinished, isPending, lastUpdated, queryCount, status]);
  return queryState;
};

var _default = useQueryState;
exports.default = _default;