"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _reduxQuery = require("redux-query");

var _useConstCallback = _interopRequireDefault(require("./use-const-callback"));

var _useMemoizedQueryConfig = _interopRequireDefault(require("./use-memoized-query-config"));

var _useQueryState = _interopRequireDefault(require("./use-query-state"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const useRequest = providedQueryConfig => {
  const reduxDispatch = (0, _reactRedux.useDispatch)();
  const isPendingRef = React.useRef(false);
  const finishedCallback = (0, _useConstCallback.default)(() => {
    isPendingRef.current = false;
  });
  const transformQueryConfig = (0, _useConstCallback.default)(queryConfig => {
    return _objectSpread({}, queryConfig, {
      unstable_preDispatchCallback: finishedCallback,
      retry: true
    });
  });
  const queryConfig = (0, _useMemoizedQueryConfig.default)(providedQueryConfig, transformQueryConfig);
  const queryState = (0, _useQueryState.default)(queryConfig);
  const dispatchRequestToRedux = (0, _useConstCallback.default)(action => {
    const promise = reduxDispatch((0, _reduxQuery.requestAsync)(action));

    if (promise) {
      isPendingRef.current = true;
    }
  });
  const dispatchCancelToRedux = (0, _useConstCallback.default)(action => {
    reduxDispatch((0, _reduxQuery.cancelQuery)(action));
    isPendingRef.current = false;
  });
  const forceRequest = React.useCallback(() => {
    if (queryConfig) {
      dispatchRequestToRedux(_objectSpread({}, queryConfig, {
        force: true
      }));
    }
  }, [dispatchRequestToRedux, queryConfig]);
  React.useEffect(() => {
    if (queryConfig) {
      dispatchRequestToRedux(queryConfig);
    }

    return () => {
      if (isPendingRef.current) {
        dispatchCancelToRedux((0, _reduxQuery.getQueryKey)(queryConfig));
      }
    };
  }, [dispatchCancelToRedux, dispatchRequestToRedux, queryConfig]);
  return [queryState, forceRequest];
};

var _default = useRequest;
exports.default = _default;